;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Missile bill from SMB3 by Romi (optimized by Blind Devil)
;
;Uses first extra bit: YES
;Clear	:unlimited turns
;Set	:single turn
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!TILE_MAP = $A6		;bullet tile
!FlashPal = $08		;what color to flash, YXPPCCCT format

X_SPEED:		db $20,$E0
SPEED_TABLE:		db $FF,$01

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			PHB
			PHK
			PLB
			%SubHorzPos()
			TYA
			STA !157C,x
			LDA X_SPEED,y
			STA !B6,x
			LDA #$0C
			STA !163E,x
			PLB
			RTL

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_ROUTINE		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_ROUTINE:		LDA $64
			PHA
			LDA !163E,x
			BEQ GFX_ROUTINE
			LDA #$10
			STA $64
GFX_ROUTINE:		JSR SPRITE_GFX
			PLA
			STA $64

			LDA !14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			LDA #$00
			%SubOffScreen()

			LDA !1602,x
			DEC A
			BEQ SPEED_DOWN
			BPL UPDATE

			%SubHorzPos()
			TYA
			CMP !157C,x
			BEQ UPDATE
			INC !1602,x

UPDATE:			JSL $018022|!BankB
			JSL $01A7DC|!BankB
RETURN:			RTS

SPEED_DOWN:		TXA
			EOR $14
			AND #$01
			BNE UPDATE
			LDY !157C,x
			LDA !B6,x
			CLC
			ADC SPEED_TABLE,y
			STA !B6,x
			PHA
			TYA
			EOR #$01
			TAY
			PLA
			CMP X_SPEED,y
			BNE UPDATE
			TYA
			STA !157C,x
			LDA !7FAB10,x
			AND #$04
			LSR
			STA !1602,x
			BRA UPDATE

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_AND:		db $07,!FlashPal

SPRITE_GFX:		%GetDrawInfo()

			STZ $02
			LDA !B6,x
			BPL GFX_LABEL00
			INC $02

GFX_LABEL00:		TXA
			EOR $13
			LSR
			AND #$01
			STA $03

			PHX
			REP #$20
			LDA $00
			STA $0300|!Base2,y
			SEP #$20

			LDA #!TILE_MAP
			STA $0302|!Base2,y

			LDX $15E9|!Base2
			LDA !15F6,x
			ORA #!FlashPal
			LDX $03
			AND TILE_AND,x
			LDX $02
			BNE NO_FLIP
			ORA #$40
NO_FLIP:
			ORA $64
			STA $0303|!Base2,y

			PLX
			LDY #$02
			LDA #$00
			JSL $01B7B3|!BankB
			RTS